--NaSH | 07/04/2011 | Argentina--

dofile("sys/lua/pb3/game.cfg")

local pbl = 0
if #paintgun<9 then
	pbl = #paintgun+1
elseif #paintgun>=9 then
	pbl = 1
end
for l = pbl,9 do
	paintgun[l] = ""
end

if stain_fadeouttime < 6 then
	stain_fadeouttime = 6
end

pellet = {} --bullets table
ipl = {} --player's info table
stain = {} --stains table
pack = {} --pellet pack id
teamalives = pbgame_lives
teamblives = pbgame_lives

--e = #pellet

for i = 1,32 do
	ipl[i] = {pg = 1,ammo = paintgun[1][4],npg = 0,pgimg = image(paintgun[1][2],1,0,200+i),wpon = 1,wpchange = 1,ins = false}
end

timer(pellet_updrate,"updatingTimer","",0)

function updatingTimer()
	if #pellet == 1 then
		updatePellet(1)
	elseif #pellet > 1 then
		for j = 1,#pellet do
			if j~=nil then
				updatePellet(j)
			end
		end
	end
end

--Function by Flacko 
function standardrad(angle)
    if (angle<-90) then
          angle = (angle + 360)
    end
    return math.rad(math.abs( angle + 90 ))-math.pi
end


function beginPellet(id)
	local pid = #pellet + 1
	local teamp = player(id,"team")
	local xp = player(id,"x")
	local yp = player(id,"y")
	local dirp = standardrad(player(id,"rot"))
	if type(dirp) ~= "number" then
		dirp = 0
	end
	pellet[pid] = {adir = dirp,x = xp,y = yp,vel = paintgun[ipl[id].pg][5],img = image(pellet_bmp,0,0,pellet_imgmode),owner = id,life = paintgun[ipl[id].pg][3]}
	if teamp == 1 then
		imagecolor(pellet[pid].img,255,0,0)
	 else
		imagecolor(pellet[pid].img,0,0,255)
	end
	if #pellet == 1 then
		--timer(pellet_updrate,"updatingTimer","",0)
	end
	--tween_move(pellet[pid],...
end

function updatePellet(id)
	local pdir = pellet[id].adir
	local impulse = pellet[id].vel
	local gox = math.cos(pdir) * impulse
	local goy = math.sin(pdir) * impulse
	local newx = pellet[id].x + gox
	local newy = pellet[id].y + goy
	pellet[id].life = pellet[id].life - impulse
	if pellet[id].life <= 0 then
		stains(id)
		finishPellet(id)
	 else
		local col = collidesPellet(id,newx,newy)
		if col>0 then
			stains(id,col)
			finishPellet(id)
			--parse("msg CRASHD WITH A PLAYER!!")
		elseif tile(math.floor(newx/32),math.floor(newy/32),"wall") then
			stains(id,newx,newy)
			finishPellet(id)
		 else
			pellet[id].x = newx
			pellet[id].y = newy
			imagepos(pellet[id].img,pellet[id].x,pellet[id].y,0)
			--parse("msg "..math.floor(newx/32).." @ "..math.floor(newy/32))
		end
	end
end

function collidesPellet(id,nx,ny)
		local tp = player(0,"table")
		--local ppx = math.floor(nx/(32-4))-3
		--local ppy = math.floor(ny/(32-4))-1
		for i=1,#tp do
			--local tpx = player(tp[i],"tilex")
			--local tpy = player(tp[i],"tilex")
			tpx = player(tp[i],"x")
			tpy = player(tp[i],"y")
			local oid = pellet[id].owner
			if i ~= oid then
				--parse("msg "..tpx.." # "..tpy)
				if tpx-15 < nx and tpx+15 > nx and tpy-15 < ny and tpy+15 > ny then
				--if tpx == ppx and tpy == ppy then
					return tp[i]
				end
			end
		--	local tpx = player(a[tp],"x")
		--	local tpx = player(a[tp],"y")
		--	if newx<
		end
		return 0
end

function stains(id,v1,v2)
	--parse("msg "..tile(math.floor(pellet[id].x/32),math.floor(pellet[id].y/32),"property"))
	if stain_mode ~= 2 then
		local sl = 4
		local sgfx = "stain"
		if v1 == nil then --finish lifetime mode
			if tile(math.floor(pellet[id].x/32),math.floor(pellet[id].y/32),"property") == 14 then
				sl = 2
				sgfx = "water"..sgfx --"waterstain"
			end
			--else: "sain"
		 elseif v2 ~= nil then --wall mode

		 else --player mode ("stained")
			sgfx = sgfx.."ed"

		end
		local sr = math.random(1,sl)
		local fgfx = "gfx/"..dir_pbgfx.."/"..sgfx..sr..".bmp"
		local sid = #stain + 1
		if sgfx == "stain" then
			stain[sid] = {img = image(fgfx,pellet[id].x,pellet[id].y,0),life = stain_fadeouttime}
			local rrot = math.random(0,360)
			imagepos(stain[sid].img,pellet[id].x,pellet[id].y,rrot)
		elseif sgfx == "waterstain" then
			stain[sid] = {img = image(fgfx,pellet[id].x,pellet[id].y,0),life = stain_fadeouttime}
			local rrot = math.random(0,360)
			imagepos(stain[sid].img,pellet[id].x,pellet[id].y,rrot)
			imagealpha(stain[sid].img,0.6)
		else
			stain[sid] = {img = image(fgfx,1,0,200+v1),life = stain_fadeouttime + stain_noremoveplayerstain}
			takelife(v1,pellet[id].owner)
		end
		if player(pellet[id].owner,"team") == 1 then
			imagecolor(stain[sid].img,255,0,0)
		 else
			imagecolor(stain[sid].img,0,0,255)
		end
	end
end

function takelife(v,a)
	local vhlt = player(v,"health")
	local vt = player(v,"team")
	local at = player(a,"team")
	if pbgame_mode == 1 then
		if vhlt - 1 == 0 then
			parse("customkill "..a.." "..pbgame_customkill.." "..v)
		else
			--if sv_ff == 1 then bla bla :( i can't know if ff is on
			if vt ~= at then
				parse("sethealth "..v.." "..vhlt-1)
			end
		end
	 else
	 if vt ~= at then
		if vt == 1 then
			teamalives = teamalives - 1
			if teamalives <= 0 then
				local ap = player(0,"team1living")
				for i=1,#ap do
					parse("killplayer "..ap[i])
				end
			end
			parse('hudtxt 2 "237028036Team A: '..teamalives..'" 10 112')
		elseif vt == 2 then
			teamblives = teamblives - 1
			if teamblives <= 0 then
				local bp = player(0,"team2living")
				for i=1,#bp do
					parse("killplayer "..bp[i])
				end
			end
			parse('hudtxt 3 "000162232Team B: '..teamblives..'" 10 125')
		end
		parse("setscore "..a.." "..player(a,"score")+1)
		parse("msg 023206133"..player(a,"name").." "..pbgame_coophitmsg.." "..player(v,"name"))
	end
	end
end

function finishPellet(id)

	freeimage(pellet[id].img)
	table.remove(pellet,id)

end

addhook("attack","onattack")
addhook("attack2","onattack")
function onattack(id)
	if ipl[id].wpon == 1 then
		local ammop = ipl[id].ammo
		if ammop >= 0 then
			ipl[id].ammo = ammop - 1
			parse('hudtxt2 '..id..' 1 "Ammo: '..ammop..'" 435 448')
			beginPellet(id)
		end
		if ammop == 0 then
			ipl[id].changewpn = 3
			parse("setweapon "..id.." 50")
			parse("strip "..id.." 11")
		end
	end
end

addhook("endround","onendround")
function onendround()
	if #pellet == 1 then
		finishPellet(1)
	elseif #pellet > 1 then
		for k = 1,#pellet do
			finishPellet(k)
		end
	end
end

addhook("startround","onstartround")
function onstartround()
	--freetimer("updatingTimer","")
	if pbgame_mode == 1 then
		for i = 1,32 do
			if player(i,"exists") and player(i,"health") > 0 then
				local ammop = ipl[i].ammo
				parse('hudtxt2 '..i..' 1 "Ammo: '..ammop..'" 435 448')
				parse('hudtxt2 '..i..' 2 "Lives:" 8 429') --10 | 438
			end
		end
	 else
		teamalives = pbgame_lives
		teamblives = pbgame_lives
		parse('hudtxt 2 "237028036Team A: '..pbgame_lives..'" 10 112') --52
		parse('hudtxt 3 "000162232Team B: '..pbgame_lives..'" 10 125') --65
		for i = 1,32 do
			if player(i,"exists") and player(i,"health") > 0 then
				local ammop = ipl[i].ammo
				parse('hudtxt2 '..i..' 1 "Ammo: '..ammop..'" 435 448')
			end
		end
	end
	local slm = #stain
	if slm == 1 then
		stain[slm] = nil
	elseif slm > 1 then
		for k = 1,slm do
			stain[k] = nil
		end
	end
	local pl = #pack
	if pl == 1 then
		pack[pl] = nil
	elseif pl > 1 then
		for k = 1,pl do
			pack[k] = nil
		end
	end
end

addhook("spawn","onspawn")
function onspawn(id)
	--ipl[id] = {pg = 1,ammo = 30}
	parse("strip "..id)
	parse("equip "..id.." 11")
	parse("sethealth "..id.." "..pbgame_lives)
	if pbgame_respawnrecharge then
		ipl[id].ammo = paintgun[ipl[id].pg][4]
	end
	if ipl[id].npg>0 then
		ipl[id].pg = ipl[id].npg
		ipl[id].npg = 0
	end
	ipl[id].pgimg = image(paintgun[ipl[id].pg][2],1,0,200+id)
end

addhook("say","onsay")
function onsay(id,msg)
	if string.sub(msg,1,1) == "!" then
	if player(id,"rcon") or player(id,"ping") == 0 then --Is server or has rcon
		--parse("msg It's a command")
		msg = string.lower(msg)
		local mlen = string.len(msg)
		local cmd = string.sub(msg,2,mlen)
		local val = string.sub(msg,-1)
		local cmdlen = string.len(cmd)
		if string.find(cmd,"lives") ~= nil then
			pbgame_lives = string.sub(cmd,7,cmdlen)
			parse("sv_msg2 "..id.." Lives per player has been changed for next round")
		 elseif cmd == "restart" then
			parse("restart")
		 elseif string.find(cmd,"stainmode") ~= nil then
			if tonumber(string.sub(cmd,11,cmdlen)) <= 3 and tonumber(string.sub(cmd,11,cmdlen)) > 0 then
				stain_mode = tonumber(string.sub(cmd,11,cmdlen))
				parse("sv_msg2 "..id.." Stain mode changed")
			end
		 elseif string.find(cmd,"updaterate") ~= nil then
			local newupdr = tonumber(string.sub(cmd,12,cmdlen))
			pellet_updrate = newupdr
			freetimer("updatingTimer","")
			timer(pellet_updrate,"updatingTimer","",0)
			parse("sv_msg2 "..id.." Updating rate changed to "..newupdr.." (default: 20)")
		 elseif string.find(cmd,"pbgm") ~= nil then
			--if string.sub(cmd,6,cmdlen) == 1 or string.sub(cmd,6,cmdlen) == 2 then
				local pbmode = tonumber(string.sub(cmd,6,cmdlen))
				if pbmode ~= pbgame_mode then
					if pbmode == 1 then
						parse("msg Paintball game mode changed to Standard")
						parse("restart")
						pbgame_mode = pbmode
					elseif pbmode == 2 then
						parse("msg Paintball game mode changed to Cooperative")
						parse("restart")
						pbgame_mode = pbmode
					end
				end
			--end
		end
	end
	end
end

addhook("serveraction","onserveraction")
function onserveraction(id,action)
	if action == 1 then
	local captions = {}
	for i = 1,9 do
		if paintgun[i] == "" then
			captions[i] = ""
		 else
			captions[i] = paintgun[i][1].."|Ammo: "..paintgun[i][4].." / Distance: "..paintgun[i][3].." / Speed: "..paintgun[i][5].." / Weight: "..paintgun[i][6] --paintgun[i][1]
		end
	end
		menu(id,pbgame_pgmenutitle.."@b,"..
		captions[1]..","..
		captions[2]..","..
		captions[3]..","..
		captions[4]..","..
		captions[5]..","..
		captions[6]..","..
		captions[7]..","..
		captions[8]..","..
		captions[9])
	elseif action == 2 then
		instructions(id)
	end
end

addhook("projectile","onprojectile")
function onprojectile(id,weapon,x,y)
	if weapon == paintboom_item and paintboom_enabled then
		local sid = #stain + 1
		local boomstain = "gfx/"..dir_pbgfx.."/boomstain.bmp"
		stain[sid] = {img = image(boomstain,x,y,0),life = stain_fadeouttime}
		if player(id,"team") == 1 then
			imagecolor(stain[sid].img,255,0,0)
		else
			imagecolor(stain[sid].img,0,0,255)
		end
		local rrot = math.random(0,360)
		imagepos(stain[sid].img,x,y,rrot)
	end
end

addhook("hit","onhit")
function onhit(id,source,weapon,hpdmg,apdmg)
	takelife(id,source)
	local sid = #stain + 1
	local totalstain = "gfx/"..dir_pbgfx.."/totallystained.bmp"
	stain[sid] = {img = image(totalstain,1,0,200+id),life = stain_fadeouttime + stain_noremoveplayerstain}
	if player(source,"team") == 1 then
		imagecolor(stain[sid].img,255,0,0)
	 else
		imagecolor(stain[sid].img,0,0,255)
	end
	return 1
end

addhook("second","onsecond")
function onsecond()
	if stain_mode == 3 then
		local sl = #stain
		if sl == 1 then
			tstain(sl)
		elseif sl > 1 then
			for st = 1,sl do
				tstain(st)
			end
		end
	end
end

function tstain(st)
	local stlife = stain[st].life
	if stlife <= stain_fadeouttime and stlife > 5 then
		stain[st].life = stain[st].life - 1
	elseif stlife <= 5 and stlife > 0 then
		imagealpha(stain[st].img,stlife/10)
		stain[st].life = stain[st].life - 1
	elseif stlife == 0 then
		freeimage(stain[st].img)
		table.remove(stain,st)
	end
end

addhook("menu","onmenu")
function onmenu(id,title,button)
	if title == pbgame_pgmenutitle then
		ipl[id].npg = button
		parse("sv_msg2 "..id.." Your paintgun will change in next round")
	end
end

addhook("select","onselect")
function onselect(id,type,mode)
	local wpon = ipl[id].wpon
	local plwp = player(id,"weapontype")
	--parse("msg "..ipl[id].pgimg)
	if itemtype(type,"slot") == 1 then
		ipl[id].wpchange = 3
		ipl[id].wpon = 1
		if ipl[id].pgimg == 0 then
			ipl[id].pgimg = image(paintgun[ipl[id].pg][2],1,0,200+id)
		end
		parse("speedmod "..id.." "..-paintgun[ipl[id].pg][6])
		parse('hudtxt2 '..id..' 1 "Ammo: '..ipl[id].ammo..'" 435 448')
		parse("setweapon "..id.." 50") --paintgun
	elseif type == paintboom_item then 
		ipl[id].wpchange = ipl[id].wpchange - 1
		if ipl[id].wpchange == 1 then
			ipl[id].wpon = 2 --paintboom
			ipl[id].wpchange = 0
			if ipl[id].pgimg then 
				freeimage(ipl[id].pgimg)
				ipl[id].pgimg = 0
			end
			parse("speedmod "..id.." 0")
			parse('hudtxt2 '..id..' 1 "" 435 448')
		end
	elseif type == 50 then --knife
		ipl[id].wpchange = ipl[id].wpchange - 1
		if ipl[id].wpchange == 1 then
			ipl[id].wpon = 0
			ipl[id].wpchange = 0
			if ipl[id].pgimg then 
				freeimage(ipl[id].pgimg)
				ipl[id].pgimg = 0
			end
			parse("speedmod "..id.." 0")
			parse('hudtxt2 '..id..' 1 "" 435 448')
		end
		--parse("msg "..ipl[id].wpchange)
	end
end

addhook("walkover","onwalkover")
function onwalkover(id,iid,type,ain,a,mode)
	if type == pellet_packid then
		local ammop = ipl[id].ammo
		if ammop <= 0 then
			parse("equip "..id.." 11")
		end
		if #pack == 1 then
			ipl[id].ammo = ipl[id].ammo + pack[1].ammoin
		elseif #pack > 1 then
			local tx = player(id,"tilex")
			local ty = player(id,"tiley")
			for p = 1, #pack do
				if tx == pack[p].x and ty == pack[p].y then
					ipl[id].ammo = ipl[id].ammo + pack[p].ammoin
				end
			end
		end
		parse("removeitem "..iid)
		if player(id,"weapontype") == 11 then
			parse('hudtxt2 '..id..' 1 "Ammo: '..ipl[id].ammo..'" 435 448')
		end
		return 1
	end
end

addhook("die","ondie")
function ondie(victim,killer,weapon,x,y)
	local tx = player(victim,"tilex")
	local ty = player(victim,"tiley")
	local pid = #pack + 1
	parse("strip "..victim.." 11")
	pack[pid] = {x = tx,y = ty,ammoin = ipl[victim].ammo}
	parse("spawnitem "..pellet_packid.." "..tx.." "..ty)
end

addhook("leave","onleave")
function onleave(id,reason)
	if ipl[id].pgimg then 
		freeimage(ipl[id].pgimg)
	end
	table.remove(ipl,id)
end

addhook("join","onjoin")
function onjoin(id)
	--4 5 6
	instructions(id)
end

function instructions(id)
	ipl[id].ins = not ipl[id].ins
	if ipl[id].ins then
		showHelp(id)
	else
		hideHelp(id)
	end
end
function showHelp(id)
	local l = pbgame_inslang
	parse('hudtxt2 '..id..' 4 "231010023'..pbgame_languages[l][1]..'" 475 41')
	parse('hudtxt2 '..id..' 5 "023206133'..pbgame_languages[l][2]..'" 475 60')
	parse('hudtxt2 '..id..' 6 "023206133'..pbgame_languages[l][3]..'" 475 75')
	parse('hudtxt2 '..id..' 7 "023206133'..pbgame_languages[l][4]..'" 475 90')
	parse('hudtxt2 '..id..' 8 "155155000Paintgun: slot 1" 475 109')
	parse('hudtxt2 '..id..' 9 "155155000Knife: slot 3" 475 124')
	parse('hudtxt2 '..id..' 10 "155155000Paintboom: slot 4" 475 139')
end
function hideHelp(id)
	parse('hudtxt2 '..id..' 4 "" 475 60')
	parse('hudtxt2 '..id..' 5 "" 475 75')
	parse('hudtxt2 '..id..' 6 "" 475 90')
	parse('hudtxt2 '..id..' 7 "" 475 60')
	parse('hudtxt2 '..id..' 8 "" 475 75')
	parse('hudtxt2 '..id..' 9 "" 475 90')
	parse('hudtxt2 '..id..' 10 "" 475 90')
end

addhook("buy","onbuy")
function onbuy(id,weapon)
	return 1
end